<?php

namespace App\Http\Controllers\Admin;

use App\Http\Controllers\Controller;
use App\Http\Requests\UserFoodRequest;
use Exception;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\RedirectResponse;
use Illuminate\Http\Request;
use Illuminate\Routing\Redirector;
use Illuminate\View\View;

use App\User;
use App\DoctorReservation;
use App\ReservationMeal;
use App\SystemFood;

class UserFoodController extends Controller
{
    /** Redirect to this path after each operation success*/
    private $redirectSuccessPath= '/admin/userfoods';
    /** View folder */
    private $viewDirectory= 'admin.userfoods.';

    /**
     * Display a listing of the resource.
     * @param Request $request
     * @return View
     */
    public function index(Request $request) :View
    {
        $title= __('userfoods.head');
        $request= $request->toArray();
        return view($this->viewDirectory.'index',compact('title'));
    }

    /**
     * return data of the userfoods.
     *
     * @param Request $request
     * @return View
     */
    public function grid(Request $request) :View
    {
        $ids = DoctorReservation::pluck('patient_id');
        $query = User::whereIn('id',$ids)->orderBy('id', 'DESC');

        if ($request->date_from) {
            $query->whereDate('created_at', '>=', $request->date_from);
        }

        if ($request->date_to) {
            $query->whereDate('created_at', '<=', $request->date_to);
        }

        if ($request->name) {
            $query->where('name', 'LIKE', '%'.$request->name.'%');
        }


        if ( !is_null($request->status) && $request->status == 0) {
            $query->onlyTrashed();
        }

        $userfoods= $query->paginate(100);

        return view($this->viewDirectory.'grid',compact('userfoods'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return View
     */
    public function create() :View
    {
        $action= route('userfoods.store');
        $head = metaFields('userfoods', 'add_new', getCurrentLocale()) ?? __('userfoods.new');
        
        $patients = User::where('role_id','6')->get();

        return view( $this->viewDirectory.'form', compact('action', 'head','patients') );
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param UserFoodRequest $request
     * @return RedirectResponse|Redirector
     */
    public function store(UserFoodRequest $request) :RedirectResponse
    {
     

        $this->saveData( $request, $request->user_id );
        
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  userfood  $userfood
     * @return View
     */
    public function edit(User $userfood): View
    {
        $action= route('userfoods.update', $userfood->id);
        $head = metaFields('userfoods', 'edit', getCurrentLocale()) ?? __('userfoods.edit');
        
        $patients = User::where('role_id','6')->get();
        $userfoods = DoctorReservation::where('patient_id',$userfood->id)->get();
        $systemfoods = SystemFood::cursor();
        
        return view( $this->viewDirectory.'form', compact('userfood', 'userfoods','action', 'head','patients','systemfoods') );
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  UserFoodRequest  $request
     * @param  userfood  $userfood
     * @return RedirectResponse|Redirector
     */
    public function update(UserFoodRequest $request, User $userfood) :RedirectResponse
    {
        $ids = DoctorReservation::where('patient_id',$userfood->id)->pluck('id');
        ReservationMeal::whereIn('reservation_id',$ids)->delete();
        DoctorReservation::where('patient_id',$userfood->id)->delete();
        $this->saveData( $request, $request->user_id );
		
        return redirect($this->redirectSuccessPath)->with('message', __('dashboard.saveDone'));
    }
    
    
    private function saveData(Request $request, int $id ):void
    {
        
       if (!is_null($request->food))
       {
           
            foreach ($request->food as $row)
            {
                if(is_null($row['dating'])){
                    $date = date('Y-m-d');
                }
                else{
                    $date = $row['dating'];
                }
              $reserve = DoctorReservation::create([
            'patient_id'=>$id,
            'dating'=>$date,
            'system_food_id'=>$row['system_food_id'],
            'category_id'=>$row['category_id'],
            'calorie_id'=>$row['calorie_id'],
            'code_id'=>$row['code_id'],
            
           
                                            ]);

                ReservationMeal::create([
                    'description'=>$row['description'],
                    'reservation_id'=>$reserve->id
                    ]);



            
              
            }
        }

    }
    /**
     * Remove the specified resource from storage.
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     * @throws Exception
     */
    public function destroy(Request $request, int $id) :JsonResponse
    {
        $user = DoctorReservation::withTrashed()->find($id);
        if ($user) {
            if ($user->deleted_at) {
                $user->forceDelete();
            } else {
                $user->delete();
            }
            return response()->json(['message'=> __('dashboard.deletedDone')]);
        } else{
            return response()->json(['message'=> __('dashboard.noResult')], 400);
        }
    }

    /**
     * Remove several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function destroyAll(Request $request) :JsonResponse
    {
        $ids= $request->ids;
        if ($request->force) {
            DoctorReservation::onlyTrashed()->whereIn('id', $ids)->forceDelete();
        } else {
            DoctorReservation::whereIn('id', $ids)->delete();
        }

        return response()->json(['message'=> __('dashboard.deletedDone')]);
    }

    /**
     * Restore the specified category from storage
     *
     * @param Request $request
     * @param int $id
     * @return JsonResponse
     */
    public function restore(Request $request, int $id) :JsonResponse
    {
        $user = DoctorReservation::withTrashed()->find($id);

        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
        return response()->json(['message'=> __('dashboard.noResult')], 400);
    }

    /**
     * Restore several pages by IDs.
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function restoreAll(Request $request) :JsonResponse
    {
        $user = DoctorReservation::whereIn('id', $request->ids)->onlyTrashed();
        if ($user){
            $user->restore();
            return response()->json(['message'=> __('dashboard.saveDone')]);
        }
    }
}
